﻿using Infragistics.Windows.Editors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Data;
using System.Windows.Media;

namespace Sample
{
    /// <summary>
    /// カレンダー日付から、土曜、日曜により文字色を変換するコンバーター
    /// </summary>
    public class HolidayToForegroundConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            // 祝日の情報を取得
            if (parameter != null && !string.IsNullOrEmpty(parameter.ToString()))
            {
                string[] holidays = parameter.ToString().Split(',');
                foreach (string holidayStr in holidays)
                {
                    DateTime holiday = DateTime.Parse(holidayStr);
                    if ((value as CalendarDay).StartDate.Date.ToString("yyyy/MM/dd") == holiday.ToString("yyyy/MM/dd"))
                    {
                        return Brushes.White;
                    }
                }

            }
            // 土曜
            if ((value as CalendarDay).StartDate.DayOfWeek == DayOfWeek.Saturday)
            {
                return Brushes.White;
            }
            // 日曜
            else if ((value as CalendarDay).StartDate.DayOfWeek == DayOfWeek.Sunday)
            {
                return Brushes.White;
            }

            return value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
